/// <reference types="react" />
import { BaseTimePickerProps } from '../TimePicker';
import { BaseDatePickerProps } from '../DatePicker';
import { WithKeyboardInputProps, WithPureInputProps } from '../Picker/makePickerWithState';
import { MaterialUiPickersDate } from '../typings/date';
export declare type DateTimePickerView = 'year' | 'date' | 'month' | 'hours' | 'minutes';
export declare type BaseDateTimePickerProps = BaseTimePickerProps & BaseDatePickerProps;
export interface DateTimePickerViewsProps extends BaseDateTimePickerProps {
    /** Array of views to show */
    views?: DateTimePickerView[];
    openTo?: DateTimePickerView;
    /** To show tabs */
    hideTabs?: boolean;
    /** Date tab icon */
    dateRangeIcon?: React.ReactNode;
    /** Time tab icon */
    timeIcon?: React.ReactNode;
    date: MaterialUiPickersDate;
}
export declare type DateTimePickerProps = WithPureInputProps & DateTimePickerViewsProps;
export declare type KeyboardDateTimePickerProps = WithKeyboardInputProps & DateTimePickerViewsProps;
export declare const DateTimePicker: import("react").FC<DateTimePickerProps>;
export declare const KeyboardDateTimePicker: import("react").FC<KeyboardDateTimePickerProps>;
