/// <reference types="react" />
import { WithKeyboardInputProps, WithPureInputProps } from '../Picker/makePickerWithState';
import { MaterialUiPickersDate } from '../typings/date';
declare type TimePickerView = 'hours' | 'minutes' | 'seconds';
export interface BaseTimePickerProps {
    /**
     * 12h/24h view for hour selection clock
     * @default true
     */
    ampm?: boolean;
    /**
     * Step over minutes
     * @default 1
     */
    minutesStep?: number;
}
export interface TimePickerViewsProps extends BaseTimePickerProps {
    /**
     * Array of views to show
     * @type {Array<"year" | "date" | "month">}
     */
    views?: TimePickerView[];
    /** First view to show in DatePicker */
    openTo?: TimePickerView;
    date: MaterialUiPickersDate;
}
export declare type TimePickerProps = WithPureInputProps & TimePickerViewsProps;
export declare type KeyboardTimePickerProps = WithKeyboardInputProps & TimePickerViewsProps;
export declare const TimePicker: import("react").FC<TimePickerProps>;
export declare const KeyboardTimePicker: import("react").FC<KeyboardTimePickerProps>;
export {};
