"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useIsLandscape = void 0;
var React = __importStar(require("react"));
var useKeyDown_1 = require("./useKeyDown");
var getOrientation = function () {
    if (typeof window === 'undefined') {
        return 'portrait';
    }
    if (window.screen && window.screen.orientation && window.screen.orientation.angle) {
        return Math.abs(window.screen.orientation.angle) === 90 ? 'landscape' : 'portrait';
    }
    // Support IOS safari
    if (window.orientation) {
        return Math.abs(Number(window.orientation)) === 90 ? 'landscape' : 'portrait';
    }
    return 'portrait';
};
function useIsLandscape(customOrientation) {
    var _a = React.useState(getOrientation()), orientation = _a[0], setOrientation = _a[1];
    var eventHandler = React.useCallback(function () { return setOrientation(getOrientation()); }, []);
    useKeyDown_1.useIsomorphicEffect(function () {
        window.addEventListener('orientationchange', eventHandler);
        return function () { return window.removeEventListener('orientationchange', eventHandler); };
    }, [eventHandler]);
    var orientationToUse = customOrientation || orientation;
    return orientationToUse === 'landscape';
}
exports.useIsLandscape = useIsLandscape;
