"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useKeyDown = exports.runKeyHandler = exports.useIsomorphicEffect = void 0;
var React = __importStar(require("react"));
exports.useIsomorphicEffect = typeof window === 'undefined' ? React.useEffect : React.useLayoutEffect;
function runKeyHandler(e, keyHandlers) {
    var handler = keyHandlers[e.key];
    if (handler) {
        handler();
        // if event was handled prevent other side effects (e.g. page scroll)
        e.preventDefault();
    }
}
exports.runKeyHandler = runKeyHandler;
function useKeyDown(active, keyHandlers) {
    var keyHandlersRef = React.useRef(keyHandlers);
    keyHandlersRef.current = keyHandlers;
    exports.useIsomorphicEffect(function () {
        if (active) {
            var handleKeyDown_1 = function (event) {
                runKeyHandler(event, keyHandlersRef.current);
            };
            window.addEventListener('keydown', handleKeyDown_1);
            return function () {
                window.removeEventListener('keydown', handleKeyDown_1);
            };
        }
    }, [active]);
}
exports.useKeyDown = useKeyDown;
